{*******************************************************}
{                                                       }
{            Avrora Card Gaming Components              }
{                                                       }
{            Copyright (c) 1999 Avrora LLC              }
{                                                       }
{*******************************************************}
{ This is PROPRIETARY SOURCE CODE of Avrora LLC;        }
{ the contents of this file may not be disclosed to     }
{ third parties, copied or duplicated in any form, in   }
{ whole or in part, without the prior written           }
{ permission of Avrora LLC.                             }
{*******************************************************}

unit UDecksDialog;

{$WEAKPACKAGEUNIT}

interface

uses
  ESCard, Windows, Forms, StdCtrls, ExtCtrls, Controls, Classes, Graphics;

type
  TDecksDialog = class(TForm)
    ButtonOk: TButton;
    ButtonCancel: TButton;
    Selector: TShape;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FPaintBitmap : TBitmap;
    FSelectedCard: TESBackType;
    FBackID : Integer;
  public
    constructor CreateDeckDialog(AOwner : TComponent; ACardBack : TESBackType);
    property SelectedCard : TESBackType read FSelectedCard;
  end;


var
  DecksDialog: TDecksDialog;

implementation

{$R *.DFM}

{ TDecksDialog }

procedure TDecksDialog.FormCreate(Sender: TObject);
var
  I, X, Y : Integer;
begin
  Top := Application.MainForm.Top + ((Application.MainForm.Height - Height) div 2) + 20;
  Left :=Application.MainForm.Left + ((Application.MainForm.Width - Width) div 2);
  InitializeImageList;
  FPaintBitmap := TBitmap.Create;
  FPaintBitmap.Canvas.Brush.Color := Color;
  FPaintBitmap.Canvas.Pen.Color := clBlack;
  FPaintBitmap.Canvas.Pen.Width := 8;
  FPaintBitmap.Width := 245  + 71;
  FPaintBitmap.Height := 216  + 96;
  X := 0;
  Y := 0;
  for I := 56 to 67 do
  begin
    case I of
      56 : begin X := 8; Y := 8; end;
      57 : begin X := 87; Y := 8; end;
      58 : begin X := 166; Y := 8; end;
      59 : begin X := 245; Y := 8; end;
      60 : begin X := 8; Y := 112; end;
      61 : begin X := 87; Y := 112; end;
      62 : begin X := 166; Y := 112; end;
      63 : begin X := 245; Y := 112; end;
      64 : begin X := 8; Y := 216; end;
      65 : begin X := 87; Y := 216; end;
      66 : begin X := 166; Y := 216; end;
      67 : begin X := 245; Y := 216; end;
    end;
    FPaintBitmap.Canvas.Draw(X, Y, ESImageList[I]);
  end;
end;

procedure TDecksDialog.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Row, Col : Integer;
begin
  Row := -1;
  Col := -1;

  case X of
    8..79    : Col := 0;
    87..158  : Col := 1;
    166..237 : Col := 2;
    245..316 : Col := 3;
  end;

  case Y of
    8..104   : Row := 0;
    112..208 : Row := 1;
    216..312 : Row := 2;
  end;

  if (Row >= 0) and (Col >= 0) then
  begin
    Selector.Top := Row * 104 + 4;
    Selector.Left := Col * 79 +4;
    case Row of
      0 : FBackID := Col + 56;
      1 : FBackID := Col + 60;
      2 : FBackID := Col + 64;
    end;
    FSelectedCard := GetCardBackType(FBackID);
  end;
end;

procedure TDecksDialog.FormDestroy(Sender: TObject);
begin
  FPaintBitmap.Free;
  DestroyImageList;
end;

procedure TDecksDialog.FormPaint(Sender: TObject);
begin
  Canvas.Draw(0,0, FPaintBitmap);
end;

constructor TDecksDialog.CreateDeckDialog(AOwner: TComponent;
  ACardBack: TESBackType);
begin
  inherited Create(AOwner);
  FSelectedCard := ACardBack;
  FBackID := GetCardBackID(ACardBack);
end;

procedure TDecksDialog.FormShow(Sender: TObject);
var
  Row, Col : Integer;
begin
  Row := 0;
  Col := 0;

  case FBackID of
    56..59 : Row := 0;
    60..63 : Row := 1;
    64..67 : Row := 2;
  end;

  if FBackID in [56, 60, 64] then
    Col := 0;
  if FBackID in [57, 61, 65] then
    Col := 1;
  if FBackID in [58, 62, 66] then
    Col := 2;
  if FBackID in [59, 63, 67] then
    Col := 3;
  Selector.Top := Row * 104 + 4;
  Selector.Left := Col * 79 +4;
end;

end.
