{*******************************************************}
{                                                       }
{            Avrora Card Gaming Components              }
{                                                       }
{            Copyright (c) 1999 Avrora LLC              }
{                                                       }
{*******************************************************}
{ This is PROPRIETARY SOURCE CODE of Avrora LLC;        }
{ the contents of this file may not be disclosed to     }
{ third parties, copied or duplicated in any form, in   }
{ whole or in part, without the prior written           }
{ permission of Avrora LLC.                             }
{*******************************************************}

unit UScoreDialog;

{$WEAKPACKAGEUNIT}

interface

uses
  ESCard, ESGameDlg, Windows, Forms, StdCtrls, SysUtils, Controls, Classes, Graphics,
  ExtCtrls;

type
  TScoreDialog = class(TForm)
    ButtonOK: TButton;
    Player01: TLabel;
    Player03: TLabel;
    Player04: TLabel;
    Player02: TLabel;
    ListBox: TListBox;
    Timer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    FPlayer1: String;
    FPlayer3: String;
    FPlayer2: String;
    FPlayer4: String;
    FHighlightLowest: Boolean;
    FCloseDelay: Integer;
    procedure SetPlayer1(const Value: String);
    procedure SetPlayer2(const Value: String);
    procedure SetPlayer3(const Value: String);
    procedure SetPlayer4(const Value: String);
    { Private declarations }
  public
    { Public declarations }
    FScoreList : TESScoreList;
    property Player1 : String read FPlayer1 write SetPlayer1;
    property Player2 : String read FPlayer2 write SetPlayer2;
    property Player3 : String read FPlayer3 write SetPlayer3;
    property Player4 : String read FPlayer4 write SetPlayer4;
    property HighlightLowest : Boolean read FHighlightLowest write FHighlightLowest;
    property CloseDelay : Integer read FCloseDelay write FCloseDelay;  
  end;

var
  ScoreDialog: TScoreDialog;

implementation

{$R *.DFM}

procedure TScoreDialog.FormCreate(Sender: TObject);
begin
  Top := Application.MainForm.Top + ((Application.MainForm.Height - Height) div 2) + 20;
  Left :=Application.MainForm.Left + ((Application.MainForm.Width - Width) div 2);
end;

procedure TScoreDialog.SetPlayer1(const Value: String);
begin
  FPlayer1 := Value;
  Player01.Caption := Value;
end;

procedure TScoreDialog.SetPlayer2(const Value: String);
begin
  FPlayer2 := Value;
  Player02.Caption := Value;
end;

procedure TScoreDialog.SetPlayer3(const Value: String);
begin
  FPlayer3 := Value;
  Player03.Caption := Value;
end;

procedure TScoreDialog.SetPlayer4(const Value: String);
begin
  FPlayer4 := Value;
  Player04.Caption := Value;
end;

procedure TScoreDialog.FormShow(Sender: TObject);
var
  I : Integer;
  S : String;
begin
  for I := Length(FScoreList) - 1 downto 0 do
  begin
    S := '';
    if FScoreList[I].Player1 >= 0 then
      S := S + IntToStr(FScoreList[I].Player1)+ #9;
    if FScoreList[I].Player2 >= 0 then
      S := S + IntToStr(FScoreList[I].Player2)+ #9;
    if FScoreList[I].Player3 >= 0 then
      S := S + IntToStr(FScoreList[I].Player3)+ #9;
    if FScoreList[I].Player4 >= 0 then
      S := S + IntToStr(FScoreList[I].Player4);
    ListBox.Items.Add(S);
  end;
  I := Length(FScoreList) - 1;
  if I >=0 then
    if FHighLightLowest then
    begin
      if (FScoreList[I].Player1 < FScoreList[I].Player2) and
         (FScoreList[I].Player1 < FScoreList[I].Player3) and
         (FScoreList[I].Player1 < FScoreList[I].Player4) then
         Player01.Font.Color := clBlue
      else
      if (FScoreList[I].Player2 < FScoreList[I].Player1) and
         (FScoreList[I].Player2 < FScoreList[I].Player3) and
         (FScoreList[I].Player2 < FScoreList[I].Player4) then
         Player02.Font.Color := clBlue
      else
      if (FScoreList[I].Player3 < FScoreList[I].Player1) and
         (FScoreList[I].Player3 < FScoreList[I].Player2) and
         (FScoreList[I].Player3 < FScoreList[I].Player4) then
         Player03.Font.Color := clBlue
      else
      if (FScoreList[I].Player4 < FScoreList[I].Player1) and
         (FScoreList[I].Player4 < FScoreList[I].Player2) and
         (FScoreList[I].Player4 < FScoreList[I].Player3) then
         Player04.Font.Color := clBlue;
    end
    else
    begin
      if (FScoreList[I].Player1 > FScoreList[I].Player2) and
         (FScoreList[I].Player1 > FScoreList[I].Player3) and
         (FScoreList[I].Player1 > FScoreList[I].Player4) then
         Player01.Font.Color := clBlue
      else
      if (FScoreList[I].Player2 > FScoreList[I].Player1) and
         (FScoreList[I].Player2 > FScoreList[I].Player3) and
         (FScoreList[I].Player2 > FScoreList[I].Player4) then
         Player02.Font.Color := clBlue
      else
      if (FScoreList[I].Player3 > FScoreList[I].Player1) and
         (FScoreList[I].Player3 > FScoreList[I].Player2) and
         (FScoreList[I].Player3 > FScoreList[I].Player4) then
         Player03.Font.Color := clBlue
      else
      if (FScoreList[I].Player4 > FScoreList[I].Player1) and
         (FScoreList[I].Player4 > FScoreList[I].Player2) and
         (FScoreList[I].Player4 > FScoreList[I].Player3) then
         Player04.Font.Color := clBlue;
    end;
    if CloseDelay > 0 then
    begin
      Timer.Interval := CloseDelay;
      Timer.Enabled := True;
    end;

end;

procedure TScoreDialog.TimerTimer(Sender: TObject);
begin
  Close;
end;

end.
